        DEVICE  ZXSPECTRUM128
        org     #6000
begin
sint:incbin "sintab.bin"
sinust:incbin "sinscroll.bin"

dointro:
 ld hl,song:call INIT
 di

    ld bc,#20af
    ld a,6 
    out (c),a

; jr $
 ld bc,Page3,a,23
 out (c),a
 ld bc,Page2;, 23->20-22
 in a,(c)
 push af

 ld a,20
 out (c),a
 ld hl,f1,de,$8000:call dzx7_standard

 ld a,$F0*0,($8000+63*256+120),a,($8000+63*256+121),a
 ld ($8000+63*256+119),a,($8000+63*256+118),a

 ld bc,Page2
 ld a,21
 out (c),a
 ld hl,f2,de,$8000:call dzx7_standard

 ld bc,Page2
 ld a,22
 out (c),a
 ld hl,f3,de,$8000:call dzx7_standard

 pop af
 ld bc,Page2
 out (c),a

;---------------------------------------------------------------------------------------
;open FMAddr access from 0x8000
FMAddr     EQU #15AF
 ld bc, 0x15AF
 ld a, $10;;;;%00010000;0x18
 out (c), a
;load CRAM
 ld de,0
 ld hl,pal0b
 ld bc,pal0e-pal0b
 ldir

 ld hl,palsb
 ld de,$180
 ld bc,palse-palsb
 ldir

;SPAl=1100
;byte 6, bits 7-4

;close FMAddr
 ld bc, 0x15AF
 xor a
 out (c), a

;PalSel = %00 //   0   0
PalSel          EQU	#07AF
PLANE0_PALETTE	equ 13			; palettes select which 16 colors part of CRAM is used for current plane, where 0 is colors 0..15, and 15 is colors 240-255
PLANE1_PALETTE	equ 14			; for 256c mode the whole CRAM is used, so this definition will be ignored
PLANE2_PALETTE	equ 15

 ld bc,PalSel
 ld a,0;PLANE0_PALETTE | ((PLANE1_PALETTE & $0C) << 2) | ((PLANE2_PALETTE & $0C) << 4)
 out (c),a
;---------------------------------------------------------------------------------------
Page3           EQU	#13AF
 ld bc,Page3
 ld a,16
 out (c),a

 ld hl,$C000,de,$C001,bc,16383,(hl),0:ldir

;T0GPage = 16 //    0   16 
 ld bc,$17AF
 ld a,16
 out (c),a


;Page3 = 17
 ld bc,Page3
 ld a,17
 out (c),a

;;;;; tilemap
 ld hl,33,($c000),hl
 ld hl,$C000,de,$C002,bc,16384-2:ldir

 ld hl,$C000+16*256,e,0;d=$40 flip Y
ft1:
 push hl,de
ft2:
 ld (hl),e:inc hl
 ld (hl),0:inc hl
 inc e
 res 3,e
 bit 7,l:jr z,ft2
 pop de,hl
 inc h
 ld a,e:add a,$40:ld e,a
 jp nc,ft1

 ld hl,#C000+19*256
 ld de,#C000+20*256
 ld ixl,4
mirror2:
 ld b,32
  push hl,de
mirror1:
 ld a,(hl):inc hl,hl
 ld (de),a:inc de
  ld a,$80;xor a
 ld (de),a:inc de
 djnz mirror1
 pop de,hl
 dec h:inc d
 dec ixl:jr nz,mirror2

;TMPage = 17; 
 ld bc,$16AF;
 ld a,$11
 out (c),a
;-----------------------------------------------------
;TSConfig = %00100100 //   0,    0 (    - ), .. 0-4095(12)  
TSCONFIG        equ $06AF
TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80

;;;	; ... and tile planes
; ld bc,$06AF
;; ld a,%00100100;TSU_T0EN|TSU_T0ZEN|TSU_SEN
; ld a,TSU_SEN|TSU_T0EN|TSU_T0ZEN
; out (c),a
;------------------------ ---------------------------
;SGPage equ $19AF;6575 -  
; ld a,20
; ld bc,SGPage
; out (c),a

;--prepare scroll
 ld hl,sprite_descr_b
 ld de,sprite_descr_b+1
 ld bc,512
 ld (hl),0
 ldir

SGPage equ $19AF;6575 -  
 ld a,20
 ld bc,SGPage
 out (c),a
;;	; ... and tile planes
 ld bc,$06AF
; ld a,%00100100;TSU_T0EN|TSU_T0ZEN|TSU_SEN
 ld a,TSU_SEN|TSU_T0EN|TSU_T0ZEN
 out (c),a
;-------------setup im 2-------------------------------
 di
 ld a,$5E,i,a
 ld hl,intvec_e,($5EFF),hl
 im 2
;---------------------------------------------  "!"   !---------------------------
 ld iy,text

t0:ei:halt
; push iy
; pop iy
 call dycp

;Border          EQU	#0FAF
; ld bc,Border,a,1
; out (c),a; 

tile_p: ld a,16
 ld bc,$17AF;T0GPage//    1
 out (c),a
 xor 2
 ld (tile_p+1),a
 ld bc,Page3
 out (c),a
 call dma_c

callv:call switch1
;--------------------kinda eorfill-----------
 ld hl,$C000
 ld b,33
eor1:
 ld de,hl:inc d
 push hl
 dup 32
 ld a,(de):or (hl):ld (de),a:inc e,l
edup
 pop hl
 inc h
 dec b
 jp nz,eor1

; ld bc,Border,a,2
; out (c),a; 

 call PLAY

; ld bc,Border,a,3
; out (c),a; 
;---------------------------------------------------------------------------------------------------------
; pop iy
; call dycp
 
 ld a,$7F
 in a,($FE)
 rra
 jp c,t0
 
 ei:halt
 ld hl,intvec,($5EFF),hl
; jr $
 jp start_hop
dycp:
;;Border          EQU	#0FAF
; ld bc,Border,a,4
; out (c),a; 

 exx
sinp: ld hl,sinust
 inc l,l
 ld (sinp+1),hl
 exx

;text_p: ld iy,text
 ld ix,sprite_descr_b
xdisp: ld de,0

 xor a
 ld (ix+0),a
 ld (ix+2),a
 ld (ix+4),a
 ld (ix+5),a

 ld a,%01100000
 ld (ix+1),a
 ld (ix+3),a
 ld bc,6:add ix,bc

 xor a
 ld (ix+0),a
 ld (ix+2),a
 ld (ix+4),a
 ld (ix+5),a

 ld a,%01100000
 ld (ix+1),a
 ld (ix+3),a
 ld bc,6:add ix,bc


 push iy
 push de

 ld a,15
prepare21:;;;;;;;;;;;;;;;12 chars
 push af
 ld a,(iy)
; or a:jr nz,end_of_text
; ld iy,text
; ld a,(iy)
;end_of_text:
 inc iy
;----put data to descriptor
 exa
 exx
 ld a,l
 add a,16
 ld l,a
 ld a,(hl)
 exx

 ld (ix+0),a;Y
 ld (ix+2),e;X

 ld (ix+1),%00100110;Ysize
 
 ld a,d:and 1:or %00000110
 ld (ix+3),a;%00000110;Xsize

 exa
 ld l,a,h,0: add hl,hl
 ld bc,letters:add hl,bc

 ld a,e:add a,32:ld e,a
 jr nc,no_inc_d
 inc d
no_inc_d:

 ld a,(hl),(ix+4),a:inc hl
 ld a,(hl)
 or %11000000;;ld a,%11000000
 ld (ix+5),a
 ld bc,6:add ix,bc
 
 pop af:dec a
 jp nz,prepare21
;---------------------------move xdisp
 pop de
 pop iy

 dec de
skippy:

 ld a,e
  cp $E0
 jr nz,no_loop_back

 inc iy
 ld a,(iy)
 or a:jr nz,no_eof
 ld iy,text
no_eof:

 ld hl,(sinp+1)
 ld a,l
  add a, 32/2
 ld l,a
 ld (sinp+1),hl

 ld de,0
no_loop_back:
 ld (xdisp+1),de
;-----------------sprite descriptor
;put_let:
; ld a,$10
; ld bc,FMAddr
; out (c),a

;---------------copy sprite data to 
DMASADDRL       EQU	#1AAF
DMASADDRH       EQU	#1BAF
DMASADDRX       EQU	#1CAF
DMADADDRL       EQU	#1DAF
DMADADDRH       EQU	#1EAF
DMADADDRX       EQU	#1FAF
DMALEN          EQU	#26AF
DMACTRL         EQU	#27AF
DMANUM          EQU	#28AF
DMASTATUS       EQU	#27AF
PAGE0           EQU	#10AF
PAGE1           EQU	#11AF
PAGE2           EQU	#12AF

; ld bc, DMACTRL
; 
;DMA_RAM_SFILE   equ $85
; ld a, DMA_RAM_SFILE
; out (c), a      ; start transaction: RAM to SFILE
;;DMACtrl         EQU	#27AF
; ld b, high DMACtrl
; xor a
; out (c),a
; call waitdma1

;      ($8000,      0000,        16 )
 ld bc, DMASADDRL
 xor a
 out (c), a      ; source: xx:xx00
 ld b, high DMASADDRH
 out (c), a      ; source: xx:00xx
 ld b, high DMASADDRX
 ld a, 2
 out (c), a      ; source: 02:xxxx

;    SFILE (0-$1FF)
 ld b, high DMADADDRL
 xor a
 out (c), a      ; destination: x00
 ld b, high DMADADDRH
 out (c), a      ; destination: 0xx

 ld b, high DMANUM
 out (c), a      ; number of bursts: 1

 ld b, high DMALEN
 ld a, 255
 out (c), a      ; number of bytes in burst: 512

 ld b, high DMACTRL
 
DMA_RAM_SFILE   equ $85
 ld a, DMA_RAM_SFILE
 out (c), a      ; start transaction: RAM to SFILE
 
 jp waitdma1
;---------------------------------------------------------------------------------------------------------
 ret;jp t0

sine_strip:
; jr $
 push de
 ld b,0;x
testlp:
 ld h,sint/256
 ld l,e,a,(hl)
 ld l,d
 add a,(hl)

 add a,$C0:ld h,a

 ld a,b
 and %11111100
 rrca
 rrca
 ld l,a

cv1: ld a,$40
 bit 0,b:jr z,no_shift
cv2: xor $44
no_shift:
 or (hl)
 ld (hl),a



 ld a,e
addv1: add a,2;4
 ld e,a
 ld a,d
addv2: add a,2;-4
 ld d,a
 inc b

 bit 7,b
 jp z,testlp
 
 pop de
 ret
switch1: ld hl,$0196-6-16
 dec hl
 ld (switch1+1),hl
 ld a,h:or l:jr nz,v11;ret nz
 ld hl,switch2,(callv+1),hl
 jp switch2;ret
v11: ld de,0
; ld a,2
; ld (addv1+1),a
; ld (addv2+1),a

 ld a,$10,(cv1+1),a
 ld a,$11,(cv2+1),a
 call sine_strip

 ld a,$20,(cv1+1),a
 ld a,$22,(cv2+1),a
 call sine_strip

 ld a,$40,(cv1+1),a
 ld a,$44,(cv2+1),a
 call sine_strip

 inc e,e
 dec d,d,d,d
 ld (v11+1),de
 ret

switch2:
;test keys
 ld hl, v01+1
 ld a,$F7:in a,(#fe)
 bit 0,a;;;; key '1'?
 jr nz,test2
 dec (hl):jr key34
test2:
 bit 1,a;'2'?
 jr nz,key34
 inc (hl)
key34:
 ld hl, v03+1
 bit 2,a;'3'?
 jr nz,test3
 dec (hl):jr key56
test3:
 bit 3,a;'4'?
 jr nz,key56
 inc (hl)
key56:
 ld hl,v05+1
 bit 4,a;'5'?
 jr nz,test4
 dec (hl):jr key_end
test4:
 ld a,$EF:in a,($FE)
 bit 4,a;'6'?
 jr nz,key_end
 inc (hl)
key_end:

;---------------RED---------------------
v1: ld de,0
 ld a,2
 ld (addv1+1),a
 ld (addv2+1),a

 ld a,$10,(cv1+1),a
 ld a,$11,(cv2+1),a

 call sine_strip

; inc e,e
 ld a,e
v01:add a,2
 ld e,a
; dec d,d,d,d
 ld a,d
v02: add a,0-4
 ld d,a
 ld (v1+1),de

;---------------GREEN---------------------
v2: ld de,0
 ld a,6
 ld (addv1+1),a

 ld a,2
 ld (addv2+1),a

 ld a,$20,(cv1+1),a
 ld a,$22,(cv2+1),a

 call sine_strip
; inc e,e
 ld a,e
v03:add a,2
 ld e,a

; dec d
 ld a,d
v04:add a,0-1
 ld d,a
 ld (v2+1),de
;---------------BLUE---------------------
v3: ld de,0

 ld a,2
 ld (addv1+1),a
 ld a,-4
 ld (addv2+1),a

 ld a,$40,(cv1+1),a
 ld a,$44,(cv2+1),a

 call sine_strip

; inc e,e,e,e
 ld a,e
v05: add a,4
 ld e,a
; inc d,d,d
 ld a,d
v06: add a,3
 ld d,a
 ld (v3+1),de

 ret
 
dma_c:
DMASAddrL       EQU	#1AAF
DMASAddrH       EQU	#1BAF
DMASAddrX       EQU	#1CAF
DMADAddrL       EQU	#1DAF
DMADAddrH       EQU	#1EAF
DMADAddrX       EQU	#1FAF
DMALen          EQU	#26AF
DMACtrl         EQU	#27AF
DMANum          EQU	#28AF
DMAStatus       EQU	#27AF
Page0           EQU	#10AF
Page1           EQU	#11AF
Page2           EQU	#12AF

	ld (dmap1+1),a
;	ld (dmap2+1),a

    ld hl,$8888
    ld (#c000),hl

    ld bc,#1AAF
    ld hl,$C000

    out (c),l;DMASAddrL       EQU	#1AAF
    inc b
    out (c),h;l;DMASAddrH       EQU	#1BAF
    inc b

;page
dmap1:    ld a,0
    out (c),a;h;DMASAddrX       EQU	#1CAF
    inc b

    ld l,2
    out (c),l;DMADAddrL       EQU	#1DAF
    inc b
    out (c),h;l;DMADAddrH       EQU	#1EAF
    inc b

;page
;dmap2:    ld a,16
    out (c),a;h;DMADAddrX       EQU	#1FAF

    ld l,255
    ld b,#26
    out (c),l;DMALen          EQU	#26AF
;2*(255+1)=512
    inc b
    inc b
    ld a,15;(15*1)*2=32, 32*512=16384
    out (c),a;;l;DMANum          EQU	#28AF
    dec b
    ld a,%00000100; FILL->RAM
    out (c),a;DMACtrl         EQU	#27AF
waitdma1:
    inf
    jp m,waitdma1
 ret
;-------------------------------------------------------------------interrupt------------------
intvec:
 push ix,iy
 push af,bc,de,hl
 exx:exa
 push af,bc,de,hl
 call PLAY
 pop hl,de,bc,af
 exx:exa
 pop hl,de,bc,af
 pop iy,ix
intvec_e:
 ei:ret

pt3play:include"PTxPlay.a80"
song:incbin"TarAmigaMemorys.pt3"
zx7:include "zx7.a80"
pal0b:
  dw $0000,$3C00,$01E0,$3DE0,$000F,$3C0F,$01EF,$3DEF,$0000,$7C00,$03E0,$7FE0,$001F,$7C1F,$03FF,$7FFF
pal0e:

palsb:
 dw $0,$15EF,$2861,$4B39,$A5,$59E8,$1400,$4965,$2E94,$34C3,$54A,$23,$668A,$4503,$1820,$0
palse:
;------------------------data for LETTERS--------------------------------
text:
 db "    123456  *W*H*O*A*! "
 db "DENPOPOV PRESENTS NEW DEMO:",34,"MERHABA",34
 db " MUSIC: TAR AMIGA MEMORYS "
 db "THIS PART IS INTERACTIVE, YOU MAY PRESS KEYS 1 TO 6   "
 db "GREETINGS TO: TS-LABS, NYUK, LESSNIK, SQ, HACKER VBI, PSB, "
 db "FUCK TO AAA, RINDEX, LVD, ALONE CODER. NOW PRESS SPACE TO "
 db "SEE SUPERHOP FRACTAL MADED BY G0BLINISH AND BY ME('ENTER' FOR CHANGE PICTURE)"
 db " BYE AND READ TEXT AGAIN: "
 db "                  "
 db 0
 db "                             "
letters:
 dup 32
 dw 0
edup

;32
 db 0,0
;33-!
 db 4,0
;34-"
 db 8,0
;35-#
 db 12,0
;36-$
 db 16,0
;37-%
 db 20,0
;38-&
 db 24,0
;39-'
 db 28,0


;40-(
 db 32,0
;41-)
 db 36,0
;42-*
 db 0,1
;43- +
 db 4,1
;44-,
 db 8,1
;45 "-"
 db 12,1
;46-.
 db 16,1
;47 -/
 db 20,1

;48-0
 db 24,1
;49-1
 db 28,1
;50-2
 db 32,1
;51-3
 db 36,1
;52-4
 db 0,2
;53-5
 db 4,2
;54-6
 db 8,2
;55-7
 db 12,2
;56-8
 db 16,2
;57-9
 db 20,2;;;;;;;;;;;;;;;;rest is:;=?
;58 :
 db 24,2
;59 ;
 db 28,2
;60
 db 0,0
;61=
 db 32,2
;62
 db 0,0
;63 - ?
 db 36,2
;64
 db 0,0


;65-A
 db %00000100*3,3; 5  6, 6  
;66-B
 db %00000100*4,3
;67-C
 db %00000100*5,3
;68-D
 db %00000100*6,3
;69-E
 db %00000100*7,3

;70-F
 db 32,3;8*%00000100,3
;71-G
 db 36,3
;72-H
 db 0,4; ! 
;73-I
 db 4,4
;74-J
 db 8,4
;75-K
 db 12,4
;76-L
 db 16,4
;77-M
 db 20,4
;78-N
 db 24,4
;79-O
 db 28,4

;80-P
 db 32,4
;81-Q
 db 36,4
;82-R
 db 0,5
;83-S
 db 4,5;;;%00000101,%00000100;Y,X  4  6
;84-T
 db 8,5
;85-U
 db 12,5
;86-V
 db 16,5
;87-W
 db 20,5
;88-X
 db 24,5
;89-Y
 db 28,5

;90-Z
 db 32,5

start_hop:
VPage		equ	#01AF
VConfig		equ	#00AF

XOffsL		equ	#02AF
XOffsH		equ	#03AF

RAMPage3	equ	#13AF

startCode
		LD	BC,VConfig    ;  : %01-320x200, %010-256 
		LD	A,%01100010; bit 4 - no tsu
		OUT	(C),A

 ld bc,$06AF
 ld a,0;%0000101
 out (c),a

;-----------------------------------------
 ld a,$20
 LD	BC,VPage      ;  ,     #20
 OUT	(C),A
 call dma_cc
;----------------------------------------;open FMAddr access from 0x0000
 ld hl,0,(pal_rgb),hl

;;FMAddr     EQU #15AF
 ld bc, FMAddr;0x15AF
 ld a, 0x10;0x18 - if $8000
 out (c), a
;load CRAM
 ld hl,pal_rgb
 ld de,0
 ld bc,512
 ldir
;close FMAddr
 ld bc, FMAddr;0x15AF
 xor a
 out (c), a

lutpl equ $4000
 ld hl,lutpl
  push hl
  ld de,hl
  inc de
  ld (hl),0
  ld bc,511
  ldir

  pop hl
  ld de,$C020;bank #
lulp1:
 ld (hl),e;bank 
 inc h
 ld (hl),d
 dec h

 inc d,d
 ld a,d:or a
 jr nz,nonextbank
 ld d,$c0
 inc e
nonextbank:
 inc l
 ld a,l
 cp 200:jr nz,lulp1
 
; ld hl,$C000
;drw: ld (hl),l:inc l:jr nz,drw

; jr $
;-----------------superhop
cx equ 200
cy equ 200
jc equ 96
ic equ 160
r1 equ 5-3;1-6
r2 equ 4;2-6
;r1-r2 is 5-3, 4-1
; ---------------------------------
hop_init:
 ld de,0;X
;hop.c;20; y=0;
 ld bc,0;Y
 xor a
 ld (z_v+1),a
;hop.c;27; while (1)//(!kbhit())
hop:
L00122:
;hop.c;30; if (y>=0)
	bit	7, b
	jr	NZ,L00102
;hop.c;32; yy=y>>SCREEN_SIZE;
    ld h,b
    ld l,c
    call shr6
;hop.c;33; j=jc+ yy;//y >> SCREEN_SIZE
 push de
 ld de,jc
 add hl,de
 pop de
; ld(j_v+1),hl
 jr	L00103
L00102:
;hop.c;37; yy=-y;
 ld hl,0
 or a
 sbc hl,bc
;hop.c;38; yy=yy>>SCREEN_SIZE;
 call shr6
;hop.c;40; j=jc-yy;
 push de
 ld de,jc
 ex de,hl
 or a
 sbc hl,de
 pop de
; ld(j_v+1),hl

L00103:
 ld(j_v+1),hl

;hop.c;48; if (j>0 && j<199)
	xor	a
	cp	l
	sbc	a,h
	jp	PO, L00174
	xor	$80
L00174:
	rlca
	and	1
	ld	ixl,a;;(ix-4),a
;hop.c;43; if (x>=0)
	bit	7, d;-9 (ix)
	jp	NZ,L00117
;hop.c;45; yy=x>>r1;
 ld h,d
 ld l,e
rv1: ld a,r1
 call shr_lp
;hop.c;46; xx=cx+y+ yy;//x >> r1;
 push bc
 add hl,bc;y+yy
 ld bc,cx
 add hl,bc;cx+y+yy
 pop bc
 ld (xx_v+1),hl
;hop.c;48; if (j>0 && j<199)
	ld	a,ixl;(ix-4)
	or	a
	jp	Z,L00118

	ld hl,(j_v+1)
	ld	a,l
	sub	$C7
	ld	a,h
	rla
	ccf
	rra
	sbc 128;sbc	a, $80
	jp	NC,L00118
;hop.c;50; yy=x>>SCREEN_SIZE;
 ld h,d
 ld l,e
 call shr6
;hop.c;51; i=ic + yy;//x >>SCREEN_SIZE;
 push bc
 ld bc,ic
 add hl,bc
 pop bc
 ld (i_v+1),hl
;hop.c;53; if (i>0 && i<319)
	xor	a
	cp	l
	sbc	a,h
	jp	PO, L00175
	xor	128;$80
L00175:
	jp	P,L00118
	push de
	ld	de, $813F;ld	de, #0x813F
	add	hl, hl
	ccf
	rr	h
	rr	l
	sbc	hl, de
	pop de
	jp	NC,L00118

 call plot

	jp	L00118
L00117:
;hop.c;64; yy=-x;
 ld hl,0
 or a
 sbc hl,de
;hop.c;65; yy=yy>>r2;
rv2: ld a,r2
 call shr_lp
;hop.c;66; xx=y+yy-cx;
 add hl,bc;y+yy
 push bc
 ld bc,cx
 or a
 sbc hl,bc
 pop bc
 ld (xx_v+1),hl
;hop.c;68; if (j>0 && j<319)
	ld	a,ixl;(ix-4)
	or	a
	jr	Z,L00118
	ld hl,(j_v+1)
	ld	a,l
	sub	$3F
	ld	a,h
	rla
	ccf
	rra
	sbc	a,$81
	jr	NC,L00118
;hop.c;71; yy=-x;
;hop.c;72; yy=yy>>SCREEN_SIZE;
 ld hl,0
 or a
 sbc hl,de
 call shr6
;hop.c;73; i=ic-yy;
 push de
 ld de,ic
 ex de,hl
 or a
 sbc hl,de
 pop de
 ld(i_v+1),hl
;hop.c;75; if  (i>0 && i<319)
	xor	a
	cp	l
	sbc	a,h
	jp	PO, L00176
	xor	128;$80
L00176:
	jp	P,L00118
	ld	a,l
	sub	$3F
	ld	a,h
	rla
	ccf
	rra
	sbc	a, $81
	jr	NC,L00118
	call plot
L00118:
;hop.c;84; y=cy-x;
 ld hl,cy
 or a
 sbc hl,de
 ld b,h
 ld c,l
;hop.c;85; z=z+1;
;hop.c;86; x=xx;
xx_v:ld de,0
;hop.c;88; if (z==0)
z_v:ld a,0
 inc a
 ld (z_v+1),a
 jr nz,skippy1
;hop.c;90; y=y-7;
 ld hl,0-7
 add hl,bc
 ld b,h
 ld c,l
skippy1:
 ld a,$BF:in a,($FE)
 rra:jp c,hop
 
 call dma_cc
vl:ld hl,vlist1+2
vvvvv:
 ld e,(hl):inc hl
 ld d,(hl):inc hl
 ld a,d:or e:jr nz,no_end_v
 ld hl,vlist1:jr vvvvv
no_end_v:
 ld (vl+1),hl
 ld a,e,(rv1+1),a
 ld a,d,(rv2+1),a
 
adv:ld a,0
 add a,$40
 ld (adv+1),a
 ld (add_v+1),a

 jp hop_init;jr $
vlist1:
 db 2,4
 db 5,3
 db 4,1
 db 1,1
 db 3,2
 dw 0

;----------------------------------------
shr6:
 ld a,3;;6;de=x,bc=y
shr_lp:
 or a
 sra h
 rr l
 dec a
 jr nz,shr_lp
 ret
 
plot:
; jr $
;-------------------------------------test plot;de=X, l=Y
 push de
 push bc
 push hl

i_v:ld de,0;DE=X
j_v:ld hl,0;plot (i,j)    L=y

 ld h,lutpl/256
;;;;;;; ld l,d;Y and bank
 ld a,(hl)
 or a:jr z,nextp
 inc h
 LD	BC,RAMPage3
 OUT	(C),A
 ld h,(hl)
;;;;;;;;;; ld l,e;suppose X
 ld l,0
 add hl,de

colr: ld a,1
 add a,11;inc a
 ld (colr+1),a

; ld d,a,e,14
; call divid
 rra
 and 31
add_v: add $80
 ld (hl),a
nextp:

 pop hl
 pop bc
 pop de
 ret
;-----------------------------------------
dma_cc:
 LD	BC,RAMPage3   ;   #20   #c000
 ld a,$20
 OUT	(C),A

    ld hl,0
    ld (#C000),hl

    ld bc,#13AF
    ld a,#20
    out (c),a
    ld bc,#20af
    ld a,6 
    out (c),a
    ld bc,#1AAF
    ld hl,#2000
    out (c),l
    inc b
    out (c),l
    inc b
    out (c),h
    inc b
    out (c),l
    inc b
    out (c),l
    inc b
    out (c),h
    ld b,#26
    dec l
    out (c),l
    inc b
    inc b
    out (c),l
    dec b
    ld a,%00000100
    out (c),a
waitdma11:
    inf
    jp m,waitdma11
    ld b,#26
    out (c),l
    inc b
    inc b
    out (c),l
    dec b
    ld a,%00000100
    out (c),a
waitdma2:
    inf
    jp m,waitdma2
	ret
;-----------------------------------------
pal_rgb:
 incbin "cgrad.tga.pal"

;------------------------------------------------------------------------
sprite_descr_b equ $8000
;sprite_descr_b:
;
;    db %00000000;Y
;    db %00100110;Ysize
;    db %00000000;X
;    db %00000110;Xsize
;    db %00000100*9;  X, R=0, S=100
;    db 3;%00000101;%11110000; pal -   Y*  0-5!
;

 ;db 0; -   
 ;db 0;%00100110; -  , Y Size: 111 (7=64);;%00111110
;7:YF
;6:LEAP-last sprite
;5:ACT-active
;4:0 reserved
;3,2,1:Y
;0:Y8=0
        ;db 0; - 
        ;db %00100110; - X Size - 7, 64 
        ;db 0; -     (   - 88)

        ;db 0;%00100000; -       .
;SPAL[7:4],TNUM[11:8]

end

 PAGE 1
 org $C000
f1:incbin "font001.zx7"
f2:incbin "font002.zx7"
f3:incbin "font003.zx7"
ff_e:

 display end

 savebin "tile.bin",begin,end-begin

 PAGE 1
 savebin "wholef.bin",f1,ff_e-f1

;        display /d,end-begin
;        SAVESNA "tile.sna", begin

;    EMPTYTRD "wf.trd"
;	SAVETRD "wf.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic
;    SAVETRD "wf.trd","wf.C",begin,end-begin
